org.apache.commons.math3.linear

## Class RealLinearOperator

- java.lang.Object
- - org.apache.commons.math3.linear.RealLinearOperator

- Direct Known Subclasses:
    AbstractRealMatrix, JacobiPreconditioner

      public abstract class RealLinearOperator
      extends Object

  This class defines a linear operator operating on real (`double`) vector spaces. No direct access to the coefficients of the underlying matrix is provided. The motivation for such an interface is well stated by Barrett et al. (1994):

  > We restrict ourselves to iterative methods, which work by repeatedly improving an approximate solution until it is accurate enough. These methods access the coefficient matrix A of the linear system only via the matrix-vector product y = A · x (and perhaps z = AT · x). Thus the user need only supply a subroutine for computing y (and perhaps z) given x, which permits full exploitation of the sparsity or other special structure of A.

  Barret et al. (1994)
    R. Barrett, M. Berry, T. F. Chan, J. Demmel, J. M. Donato, J. Dongarra, V. Eijkhout, R. Pozo, C. Romine and H. Van der Vorst, Templates for the Solution of Linear Systems: Building Blocks for Iterative Methods, SIAM
  Since:
    3.0
  Version:
    $Id: RealLinearOperator.java 1244107 2012-02-14 16:17:55Z erans $

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `RealLinearOperator()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract int` | `getColumnDimension()` Returns the dimension of the domain of this operator.
    `abstract int` | `getRowDimension()` Returns the dimension of the codomain of this operator.
    `boolean` | `isTransposable()` Returns `true` if this operator supports `operateTranspose(RealVector)`.
    `abstract RealVector` | `operate(RealVector x)` Returns the result of multiplying `this` by the vector `x`.
    `RealVector` | `operateTranspose(RealVector x)` Returns the result of multiplying the transpose of `this` operator by the vector `x` (optional operation).

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RealLinearOperator

          public RealLinearOperator()

  - ### Method Detail

    - #### getRowDimension

          public abstract int getRowDimension()

      Returns the dimension of the codomain of this operator.
      Returns:
        the number of rows of the underlying matrix

    - #### getColumnDimension

          public abstract int getColumnDimension()

      Returns the dimension of the domain of this operator.
      Returns:
        the number of columns of the underlying matrix

    - #### operate

          public abstract RealVector operate(RealVector x)

      Returns the result of multiplying `this` by the vector `x`.
      Parameters:
        `x` - the vector to operate on
      Returns:
        the product of `this` instance with `x`
      Throws:
        `DimensionMismatchException` - if the column dimension does not match the size of `x`

    - #### operateTranspose

          public RealVector operateTranspose(RealVector x)
                                      throws DimensionMismatchException,
                                             UnsupportedOperationException

      Returns the result of multiplying the transpose of `this` operator by the vector `x` (optional operation). The default implementation throws an `UnsupportedOperationException`. Users overriding this method must also override `isTransposable()`.
      Parameters:
        `x` - the vector to operate on
      Returns:
        the product of the transpose of `this` instance with `x`
      Throws:
        `DimensionMismatchException` - if the row dimension does not match the size of `x`
        `UnsupportedOperationException` - if this operation is not supported by `this` operator

    - #### isTransposable

          public boolean isTransposable()

      Returns `true` if this operator supports `operateTranspose(RealVector)`. If `true` is returned, `operateTranspose(RealVector)` should not throw `UnsupportedOperationException`. The default implementation returns `false`.
      Returns:
        `false`

Copyright © 2003-2012 The Apache Software Foundation. All Rights Reserved.